package fr.wfn.astro.time.gui;

import java.util.Vector;
import java.util.Enumeration;

import fr.wfn.astro.time.utils.CalendarConverter;
import fr.wfn.astro.time.utils.SideralTime;

/**
 * Ce type a t cr dans VisualAge.
 */
public class ApplicationModel {

	private int _anneeDeb;
	private int _anneeFin;

	private int _moisDeb;
	private int _moisFin;
	
	private int _jourDeb;
	private int _jourFin;

	private double _longitude;
	private Vector _modelListeners ;
	

	public static final int DATE 					= 0;
	public static final int LOC_SID_TIME_H 			= 1;
	public static final int LOC_SID_TIME_M 			= 2;
	public static final int LOC_SID_TIME_18HTU_H 	= 3;
	public static final int LOC_SID_TIME_18HTU_M 	= 4;
	public static final int LOC_SID_TIME_22HTU_H 	= 5;
	public static final int LOC_SID_TIME_22HTU_M 	= 6;

	public static final int NBR_COL = 7;

	private Vector _dataVector;
	
	
	
/**
 * Commentaire relatif au constructeur ApplicationModel.
 */
public ApplicationModel() {
	super();

	_modelListeners = new Vector(0);

	
}
/**
 * Cette mthode a t cre dans VisualAge.
 * @param l ModelListener
 */
public void addModelListener(ModelListener l) {
	_modelListeners.addElement(l);
}
/**
 * Cette mthode a t cre dans VisualAge.
 */
private void computeData() {

	_dataVector = new Vector();

	String[] aRecord = new String[NBR_COL];

	CalendarConverter converter = new CalendarConverter(0);
	SideralTime sideralTime = new SideralTime();
	
	converter.setDate(_jourDeb,_moisDeb,_anneeDeb);
	double jd1 = converter.getJD();
	
	converter.setDate(_jourFin,_moisFin,_anneeFin);
	double jd2 = converter.getJD();


	double jd = jd1;
	
	while (jd < jd2 +1)
	{
		converter.setJD(jd);

		aRecord[DATE] = getFormated(converter.getJour(),2,'0') + " - " +
						getFormated(converter.getMois(),2,' ')  +" - " +
						getFormated(converter.getAnnee(),4,' ');

		sideralTime.setTime(converter.getAnnee(),
							converter.getMois(),
							converter.getJour(),
							0,
							0,
							_longitude);
	
						
		aRecord[LOC_SID_TIME_H] =  getFormated(sideralTime.getSideralHour(),2,' ') ;
		aRecord[LOC_SID_TIME_M] =  getFormated(sideralTime.getSideralMinute(),2,'0');

		sideralTime.setTime(converter.getAnnee(),
							converter.getMois(),
							converter.getJour(),
							18,
							0,
							_longitude);

		                       
		aRecord[LOC_SID_TIME_18HTU_H] =  getFormated(sideralTime.getSideralHour(),2,' ') ;
		aRecord[LOC_SID_TIME_18HTU_M] =  getFormated(sideralTime.getSideralMinute(),2,'0');

		sideralTime.setTime(converter.getAnnee(),
							converter.getMois(),
							converter.getJour(),
							22,
							0,
							_longitude);

		                       
		aRecord[LOC_SID_TIME_22HTU_H] =  getFormated(sideralTime.getSideralHour(),2,' ') ;
		aRecord[LOC_SID_TIME_22HTU_M] =  getFormated(sideralTime.getSideralMinute(),2,'0');

		_dataVector.addElement(aRecord)	;

		 aRecord = new String[NBR_COL];

		 jd = jd + 1;
	}
	
}
/**
 * Cette mthode a t cre dans VisualAge.
 * @return java.util.Vector
 */
public Vector getData() {
	return _dataVector;
}
/**
 * Cette mthode a t cre dans VisualAge.
 * @return java.lang.String
 * @param s java.lang.String
 * @param digit int
 */
private String getFormated(int i,int digit,char fill) {
	return getFormated(Integer.toString(i),digit,fill);
}
/**
 * Cette mthode a t cre dans VisualAge.
 * @return java.lang.String
 * @param s java.lang.String
 * @param digit int
 */
private String getFormated(String s,int digit,char fill) {


	int l = s.length();

	if ( l >= digit)
	{ 
		return  s.substring(0,digit);
	}

	String f = "";
	for ( int i = 0;i < digit - l ; i++ )
	{
		f = f + fill;
	}

	return f + s;
}
/**
 * Cette mthode a t cre dans VisualAge.
 * @return double
 */
public double getLongitude() {
	return _longitude;
}
/**
 * Cette mthode a t cre dans VisualAge.
 * @param A1 java.lang.String
 * @param M1 java.lang.String
 * @param J1 java.lang.String
 * @param A2 java.lang.String
 * @param M2 java.lang.String
 * @param J2 java.lang.String
 * @param L java.lang.String
 */
public void setParam(String A1, String M1, String J1, String A2, String M2, String J2, String L) {

	_anneeDeb = Integer.parseInt(A1);
	_anneeFin = Integer.parseInt(A2);

	_moisDeb = Integer.parseInt(M1);
	_moisFin = Integer.parseInt(M2);

	_jourDeb = Integer.parseInt(J1);
	_jourFin = Integer.parseInt(J2);

	_longitude =Double.valueOf(L).doubleValue();
	
	computeData();

	updateModelListener();
	
}
/**
 * Cette mthode a t cre dans VisualAge.
 */
private void updateModelListener() {


	for(Enumeration e =_modelListeners.elements();e.hasMoreElements();)
	{

		((ModelListener)e.nextElement()).modelHasChanged();
	}
	
	
}
}