package fr.wfn.astro.time.gui;

import java.awt.*;
import java.awt.event.*;

/**
 * Ce type a t cr dans VisualAge.
 */
public class EcrSaisieDate implements ActionListener,ModelListener{

	private SideralEphem _parent;
	private double _defaultLong = 0;
	
	private Panel _mainPanel;

	private GridBagLayout gbl;
	
	private TextField _tf_AnneeD;
	private TextField _tf_MoisD;
	private TextField _tf_JourD;

	private TextField _tf_AnneeF;
	private TextField _tf_MoisF;
	private TextField _tf_JourF;
	
	private TextField _tf_Longitude;

	private Label _l_message;

	private Button    _b_compute;
/**
 * Commentaire relatif au constructeur EcrSaisieDate.
 */
public EcrSaisieDate(SideralEphem parent,double defaultLong) {
	super();
	_parent = parent;
	_parent.getModel().addModelListener(this);

	_defaultLong = defaultLong;


	
}
/**
 * Cette mthode a t cre dans VisualAge.
 * @param e java.awt.event.ActionEvent
 */
public void actionPerformed(ActionEvent e) {

	if (e.getSource() == _b_compute)
	{
		if (	Valider.isDate(_tf_AnneeD.getText(),
							_tf_MoisD.getText(),
							_tf_JourD.getText()) &&
				Valider.isDate(_tf_AnneeF.getText(),
							_tf_MoisF.getText(),
							_tf_JourF.getText()) &&
				Valider.isLongitude( _tf_Longitude.getText()))
		{
			
				_l_message.setText("Calcul en cours ...");
				_l_message.setForeground(Color.orange);
				_l_message.repaint();	
				_parent.getModel().setParam(
							_tf_AnneeD.getText(),
							_tf_MoisD.getText(),
							_tf_JourD.getText(), 
				  			_tf_AnneeF.getText(),
							_tf_MoisF.getText(),
							_tf_JourF.getText(),
							_tf_Longitude.getText());

				
				return;
				
		}
	}

				_l_message.setText("Saisie incorrecte ...");
				_l_message.setForeground(Color.red);
				_l_message.repaint();
}
/**
 * Cette mthode a t cre dans VisualAge.
 * @return java.awt.Panel
 */
public Panel getView() {
	if ( _mainPanel == null )
	{
		// contraintes
		_mainPanel = new Panel();
		gbl = new GridBagLayout();
		_mainPanel.setLayout(gbl);

		_l_message = new Label();
		
		// DATE DEPART
		Label titre = new Label("Saisie de la Date de Dpart:");
		titre.setForeground(ApplicationLayout.getTitleColor());
		Adder.add(gbl,_mainPanel,
			titre									,	0,0,1,1);
		Adder.add(gbl,_mainPanel,
			getViewDateStart(),							0,1,1,1);

		// DATE FIN
		titre = new Label("Saisie de la Date de Fin:");
		titre.setForeground(ApplicationLayout.getTitleColor());
		Adder.add(gbl,_mainPanel,
			titre								,	1,0,1,1);
		Adder.add(gbl,_mainPanel,
			getViewDateEnd(),						1,1,1,1);
		
		// LONGITUDE
		_tf_Longitude = new TextField(Double.toString(_defaultLong));
		_tf_Longitude.setSize(30,25);
		_tf_Longitude.setBackground(ApplicationLayout.getSubPanelColor());
		titre = new Label("Longitude :");
		titre.setForeground(ApplicationLayout.getTitleColor());

		Adder.add(gbl,_mainPanel,
			titre					,				0,2,1,1);
		Adder.add(gbl,_mainPanel,
			_tf_Longitude,							1,2,1,1);

		// BOUTON
		_b_compute = new Button("CALCULER");
		_b_compute.addActionListener(this);

		Adder.add(gbl,_mainPanel,
			_b_compute,								0,3,2,1);
		
		Adder.add(gbl,_mainPanel,_l_message,		0,4,2,1);

	}
	return _mainPanel;
}
/**
 * Cette mthode a t cre dans VisualAge.
 * @return java.awt.Panel
 */
private Panel getViewDateEnd() {
	Panel _mainPanel = new Panel();

	_mainPanel.setBackground(ApplicationLayout.getSubPanelColor());

		// contraintes
		GridBagLayout gbl = new GridBagLayout();
		_mainPanel.setLayout(gbl);
		// ANNEE
		_tf_AnneeF = new TextField(4);
		
		Adder.add(gbl,_mainPanel,new Label("Anne :"),	0,0,1,1);
		Adder.add(gbl,_mainPanel,_tf_AnneeF,			1,0,2,1);
		
		// MOIS
		_tf_MoisF = new TextField();
		Adder.add(gbl,_mainPanel,new Label("Mois :"),	0,1,1,1);
		Adder.add(gbl,_mainPanel,_tf_MoisF,				1,1,2,1);
		
		// JOUR
		_tf_JourF = new TextField();
		Adder.add(gbl,_mainPanel,new Label("Jour :"),	0,2,1,1);
		Adder.add(gbl,_mainPanel,_tf_JourF,				1,2,2,1);


	return _mainPanel;
}
/**
 * Cette mthode a t cre dans VisualAge.
 * @return java.awt.Panel
 */
private Panel getViewDateStart() {

	Panel _mainPanel = new Panel();
	_mainPanel.setBackground(ApplicationLayout.getSubPanelColor());

		// contraintes
		GridBagLayout gbl = new GridBagLayout();
		_mainPanel.setLayout(gbl);
		// ANNEE
		_tf_AnneeD = new TextField(4);
		Adder.add(gbl,_mainPanel,new Label("Anne :"),	0,0,1,1);
		Adder.add(gbl,_mainPanel,_tf_AnneeD,			1,0,2,1);
		
		// MOIS
		_tf_MoisD = new TextField();
		Adder.add(gbl,_mainPanel,new Label("Mois :"),	0,1,1,1);
		Adder.add(gbl,_mainPanel,_tf_MoisD,				1,1,2,1);
		
		// JOUR
		_tf_JourD = new TextField();
		Adder.add(gbl,_mainPanel,new Label("Jour :"),	0,2,1,1);
		Adder.add(gbl,_mainPanel,_tf_JourD,				1,2,2,1);


	return _mainPanel;
}
/**
 * Cette mthode a t cre dans VisualAge.
 */
public void modelHasChanged() {

	_l_message.setText("Calcul TERMINE ");
	_l_message.setForeground(Color.green);
	_l_message.repaint();
	
}
}