package fr.wfn.astro.time.gui;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
/**
 * Ce type a t cr dans VisualAge.
 */
public class EcrVisuData implements ModelListener{

	private SideralEphem _parent;
	private Panel _dispPanel;
	private ScrollPane _scrollPane;
	private Panel _mainPanel;
	private GridBagLayout gbl;
/**
 * Commentaire relatif au constructeur EcrVisuData.
 */
public EcrVisuData(SideralEphem parent) {
	super();
	_parent =parent;
	_parent.getModel().addModelListener(this);
}
/**
 * Cette mthode a t cre dans VisualAge.
 */
private void clearPanel() {

	getDisplay().removeAll();
	getDisplay().repaint();
}
private Panel getDisplay() {
	
	if ( _dispPanel == null )
	{
		// contraintes
		_dispPanel = new Panel();
		 gbl = new GridBagLayout();
		_dispPanel.setLayout(gbl);
	
	}
	return _dispPanel;
}
public Panel getView() {
	if ( _mainPanel == null )
	{
		// contraintes
		_mainPanel = new Panel(new BorderLayout());

		Label titre = 	new Label("Affichage des Heures Sidrales");
		titre.setForeground(ApplicationLayout.getTitleColor());
		
		_mainPanel.add(	titre ,BorderLayout.NORTH);

		_scrollPane = new ScrollPane(ScrollPane.SCROLLBARS_AS_NEEDED);
		_scrollPane.add(getDisplay());
		_scrollPane.setSize(ApplicationLayout.getAppSize());

		_mainPanel.add(_scrollPane,BorderLayout.CENTER);
		
	}
	return _mainPanel;
}
/**
 * Cette mthode a t cre dans VisualAge.
 */
public void modelHasChanged() {

	clearPanel();

	printData();
}
/**
 * Cette mthode a t cre dans VisualAge.
 */
private void printData() {


		
	Vector data = _parent.getModel().getData();

	int i = 1;
	for(Enumeration e = data.elements(); e.hasMoreElements();)
	{
		String[] ligne = (String[])e.nextElement();

		Label l0 = new Label(Integer.toString(i));
		l0.setBackground(Color.cyan);
		
		Label l1 = new Label(ligne[_parent.getModel().DATE]);
		Label l2 = new Label(" 0 TU : " +	ligne[_parent.getModel().LOC_SID_TIME_H] + "h"+
							 			ligne[_parent.getModel().LOC_SID_TIME_M]);
		Label l3 = new Label("18 TU : " +	ligne[_parent.getModel().LOC_SID_TIME_18HTU_H]+"h"+
												ligne[_parent.getModel().LOC_SID_TIME_18HTU_M]);
		Label l4 = new Label("22 TU : " +	ligne[_parent.getModel().LOC_SID_TIME_22HTU_H]+"h"+
												ligne[_parent.getModel().LOC_SID_TIME_22HTU_M]);


		l0.setFont(ApplicationLayout.getTabFont());		
		l1.setFont(ApplicationLayout.getTabFont());
		l2.setFont(ApplicationLayout.getTabFont());
		l3.setFont(ApplicationLayout.getTabFont());
		l4.setFont(ApplicationLayout.getTabFont());
		


		

		if ( (i%2)>0)
		{
			l1.setBackground(Color.yellow);
			l2.setBackground(Color.yellow);
			l3.setBackground(Color.yellow);
			l4.setBackground(Color.yellow);

		}
		else
		{
			l1.setBackground(Color.white);
			l2.setBackground(Color.white);
			l3.setBackground(Color.white);
			l4.setBackground(Color.white);
		}
				
		
		Adder.add(	gbl,
					getDisplay(),
					l0,			0,i,1,1);

		Adder.add(	gbl,
					getDisplay(),
					l1,			1,i,1,1);

		Adder.add(	gbl,
					getDisplay(),
					l2,			2,i,1,1);

		Adder.add(	gbl,
					getDisplay(),
					l3,			3,i,1,1);

		Adder.add(	gbl,
					getDisplay(),
					l4,			4,i,1,1);
		i++;
	}
	
}
}