package fr.wfn.astro.time.gui;

import java.awt.*;
import java.awt.event.WindowListener;
import java.awt.event.WindowEvent;

/**
 * Ce type a t cr dans VisualAge.
 */
public class SideralEphem implements WindowListener{

	private Panel _mainPanel;
	private Frame _mainFrame;

	private MenuBar _menuBar;

	private ApplicationModel _model;

	// identifiant des crans

	public static final String ECR_FIC_VISU ="ECR_FIC_VISU";
	public static final String ECR_DATE_SAISIE ="ECR_DATE_SAISIE";
	public static final String ECR_DTA_VISU ="ECR_DTA_VISU";
		
	//
	private String _defaultDir  	= "C:/";
	private String _defaultFile 	= "HeureSideral.txt";
	private String _defaultFileHtml = "Sideral.html";
	
	private double _defaultLong 	= 0;
	
	
	
/**
 * Commentaire relatif au constructeur SideralEphem.
 */
public SideralEphem(String dirName, String fileName, String longitude) {
	super();

	if ((fileName != "")&&(dirName != ""))
	{
		_defaultDir = dirName;
		_defaultFile = fileName;
	}

	try
	{
		_defaultLong = Double.valueOf(longitude).doubleValue();
	}
	catch(NumberFormatException e)
	{
		_defaultLong = 0; //GreenWich
	}

	_model = new ApplicationModel();
}
/**
 * Cette mthode a t cre dans VisualAge.
 */
private void closeApplication() {
}
/**
 * Cette mthode a t cre dans VisualAge.
 * @return java.awt.Panel
 */
private Panel getEcrDateSaisie() {
	
	return (new EcrSaisieDate(this,_defaultLong)).getView();
}
/**
 * Cette mthode a t cre dans VisualAge.
 * @return java.awt.Panel
 */
private Panel getEcrVisuData() {
	return (new EcrVisuData(this)).getView();
}
/**
 * Cette mthode a t cre dans VisualAge.
 * @return java.awt.Panel
 */
private Panel getEcrVisuFichier() {
	return new Panel();
}
/**
 * Cette mthode a t cre dans VisualAge.
 * @return java.awt.Panel
 */
public Frame getFrame() {

	if (_mainFrame == null)
	{
		_mainFrame = new Frame();
		_mainFrame.setTitle(ApplicationLayout.getAppTitre());
		_mainFrame.addWindowListener(this);
		_mainFrame.add(this.getView());
		_mainFrame.setSize(ApplicationLayout.getAppSize());

		_mainFrame.setMenuBar(getMenuBar());
		
	}	
	return _mainFrame;
}
/**
 * Cette mthode a t cre dans VisualAge.
 * @return java.awt.MenuBar
 */
private MenuBar getMenuBar() {

	if (_menuBar == null)
	{
		_menuBar = new MenuBar();

		MenuManager menuManag = new MenuManager(this);

		//
			Menu _menuFichier = new Menu("Fichier");

/*				MenuItem _itemVoirFic = new MenuItem("Visualiser Fichier");
				_itemVoirFic.addActionListener(menuManag);
				_itemVoirFic.setActionCommand(MenuCmdIntf.VOIR_FICHIER);
				_menuFichier.add(_itemVoirFic);
*/
				MenuItem _itemSauvFic = new MenuItem("Sauver");
				_itemSauvFic.addActionListener(menuManag);
				_itemSauvFic.setActionCommand(MenuCmdIntf.SAUVER_FICHIER);
				_menuFichier.add(_itemSauvFic);

				MenuItem _itemSauvFicHtml = new MenuItem("Sauver Html");
				_itemSauvFicHtml.addActionListener(menuManag);
				_itemSauvFicHtml.setActionCommand(MenuCmdIntf.SAUVER_FICHIER_HTML);
				_menuFichier.add(_itemSauvFicHtml);

			_menuBar.add(_menuFichier);
		//
		//
			Menu _menuFichier2 = new Menu("Paramtres");

				MenuItem _itemParametres = new MenuItem("Saisie Paramtres");
				_itemParametres.addActionListener(menuManag);
				_itemParametres.setActionCommand(MenuCmdIntf.SAISIE_PARAMETRES);
				_menuFichier2.add(_itemParametres);

				MenuItem _itemResCalc = new MenuItem("Visualisation Calculs");
				_itemResCalc.addActionListener(menuManag);
				_itemResCalc.setActionCommand(MenuCmdIntf.VOIR_CALCUL);
				_menuFichier2.add(_itemResCalc);


			_menuBar.add(_menuFichier2);
		//
		
	}		
	return _menuBar;
}
/**
 * Cette mthode a t cre dans VisualAge.
 * @return fr.wfn.astro.time.gui.ApplicationModel
 */
public ApplicationModel getModel() {
	return _model;
}
/**
 * Cette mthode a t cre dans VisualAge.
 * @return java.awt.Panel
 */
public Panel getView() {

	if (_mainPanel == null)
	{
		_mainPanel = new Panel(new CardLayout());

		_mainPanel.setBackground(ApplicationLayout.getBackgroundColor());
		_mainPanel.setSize(ApplicationLayout.getAppSize());
		
		_mainPanel.add(ECR_DATE_SAISIE, getEcrDateSaisie());
		_mainPanel.add(ECR_FIC_VISU,getEcrVisuFichier());
		_mainPanel.add(ECR_DTA_VISU,getEcrVisuData());
						
	}	
	return _mainPanel;
}
/**
 * Cette mthode a t cre dans VisualAge.
 */
public void saveFile() {

	FileDialog fileDialog = new FileDialog(getFrame());

	fileDialog.setMode(FileDialog.SAVE);
	fileDialog.setDirectory(_defaultDir);
	fileDialog.setFile(_defaultFile);
		
	fileDialog.setVisible(true);

	SideralFileParser parser = new SideralFileParser();
	parser.parse(this,fileDialog.getDirectory()+fileDialog.getFile());
	
}
/**
 * Cette mthode a t cre dans VisualAge.
 */
public void saveHTMLFile() {

	FileDialog fileDialog = new FileDialog(getFrame());

	fileDialog.setMode(FileDialog.SAVE);
	fileDialog.setDirectory(_defaultDir);
	fileDialog.setFile(_defaultFileHtml);
		
	fileDialog.setVisible(true);

	SideralFileParser parser = new SideralFileParser();
	parser.parseHTML(this,fileDialog.getDirectory()+fileDialog.getFile());
	
}
/**
 * Cette mthode a t cre dans VisualAge.
 * @param e java.awt.event.WindowEvent
 */
public void windowActivated(WindowEvent e) {
}
/**
 * Cette mthode a t cre dans VisualAge.
 * @param e java.awt.event.WindowEvent
 */
public void windowClosed(WindowEvent e) {

}
/**
 * Cette mthode a t cre dans VisualAge.
 * @param e java.awt.event.WindowEvent
 */
public void windowClosing(WindowEvent e) {
	this.closeApplication();
	System.exit(0);
}
/**
 * Cette mthode a t cre dans VisualAge.
 * @param e java.awt.event.WindowEvent
 */
public void windowDeactivated(WindowEvent e) {
}
/**
 * Cette mthode a t cre dans VisualAge.
 * @param e java.awt.event.WindowEvent
 */
public void windowDeiconified(WindowEvent e) {
}
/**
 * Cette mthode a t cre dans VisualAge.
 * @param e java.awt.event.WindowEvent
 */
public void windowIconified(WindowEvent e) {
}
/**
 * Cette mthode a t cre dans VisualAge.
 * @param e java.awt.event.WindowEvent
 */
public void windowOpened(WindowEvent e) {
}
}