package fr.wfn.astro.time.gui;

import java.io.*;
import java.util.*;
import java.awt.Dialog;
import java.awt.Label;
import java.awt.*;
import java.awt.event.*;
/**
 * Ce type a t cr dans VisualAge.
 */
public class SideralFileParser {

	private  SideralEphem _parentApp ;
	private  Dialog d;

/**
 * Cette mthode a t cre dans VisualAge.
 */
public SideralFileParser() {
}
private String getHTMLFooter(){
	String s =	"</BODY>  \n" +
				"</HTML>  \n";
	return s;
}
private String getHTMLHeader(double longitude){

	String s =	"<HTML>  \n" +
				"<TITLE>  Heure Sidrale  0H T.U., 18 H T.U. et 22 H T.U. </TITLE> \n" +
				
				"<STYLE type =\"text/css\">         \n" +
				".paire	{							\n" +	
				"			font-size  : 10 px ;	\n" +
				"			background : #FFFFF0;   \n" +
				"		}							\n" +
				".impaire{							\n" +
				"			font-size  : 10 px ;	\n" +
				"			background : #F0F0F0;	\n" +
				"		}							\n" +
				".entete {							\n" +
				"			background  : #F0FFF0;	\n" +
				"		}							\n" +
				"TD     {							\n" +
				"			border-bottom	    : solid;	\n" +
				"			text-align : center ;	\n" +
				"			border-bottom-width : 1px;	\n" +
				"			border-color : black;	\n" +
				"			font-family: Comic Sans MS;	\n" +
				"		}							\n" +
				"TABLE  {							\n" +
				"		}							\n" +
				"</STYLE>							\n" +				
				"<BODY> \n"  +
				"<CENTER> \n"  +
				"	<H1> Heure Sidrale pour L = "+Double.toString(longitude)+" </H1> \n"  +
				"</CENTER> \n"  ;
		
	return s;
}
private String getHTMLTableFooter(){
	String s =	"</TABLE>  \n" +
				"</CENTER>  \n" ;
	return s;}
private String getHTMLTableHeader(){
	String s =	"<CENTER>  \n" +	
				"<TABLE>  \n" +
				"<B><TR class=\"entete\">\n" +
				"<TD>  &nbsp i &nbsp </TD> \n" +
				"<TD> Date </TD> \n" +
				"<TD>  &nbsp 0 TU   &nbsp  </TD> \n" +
				"<TD>  &nbsp  18 TU  &nbsp  </TD> \n" +
				"<TD>   &nbsp 12 TU  &nbsp   </TD> \n" +
				"</TR></B>\n";
	return s;
}
public  void parse( SideralEphem parent, String filePath){

	_parentApp = parent;

	ApplicationModel model = parent.getModel();


	if (model.getData() == null )
	{
		return;
	}

	
	int i = 1;
	try
	{
		PrintWriter sortie = new PrintWriter( new FileWriter(filePath));

		sortie.println(	"i"+ ";"+
							"date"+";"+
							"HS a 0 HTU"+";"+
							"m"+";"+
							"HS a 18 HTU"+";"+
							"m"+";"+
							"HS a 22 HTU"+";"+
							"m"
							);
			sortie.flush();


		
		for (Enumeration e = model.getData().elements();e.hasMoreElements();)
		{
			String[] record = (String[])e.nextElement();


			sortie.println(	Integer.toString(i) + ";"+
							record[model.DATE]+";"+
							record[model.LOC_SID_TIME_H]+";"+
							record[model.LOC_SID_TIME_M]+";"+
							record[model.LOC_SID_TIME_18HTU_H]+";"+
							record[model.LOC_SID_TIME_18HTU_M]+";"+
							record[model.LOC_SID_TIME_22HTU_H]+";"+
							record[model.LOC_SID_TIME_22HTU_M]);
			sortie.flush();
			i++;
		}
		sortie.close();
			
	}
	catch (Exception ex)
	{
		
		d = new Dialog(parent.getFrame()," Erreur ! ");
		d.setSize(200,100);
		d.addWindowListener(new WindowListener(){
				public void windowOpened(WindowEvent ev){};
				public void windowActivated(WindowEvent ev){}
				public void windowIconified(WindowEvent ev){}
				public void windowClosed(WindowEvent ev){}
				public void windowClosing(WindowEvent ev){
						d.dispose();
					}
				public void windowOpened(WindowEvent ev){}
				public void windowDeactivated(WindowEvent ev){}
				public void windowDeiconified(WindowEvent ev){}
							
			});
		Panel p = new Panel(new BorderLayout());
		
		Label msg = new Label(" Message : "+ ex.getMessage());
		p.add(msg,BorderLayout.CENTER);
		d.add(p);
		d.setVisible(true);
	}
	

	

	
}
public  void parseHTML( SideralEphem parent, String filePath){

	_parentApp = parent;

	ApplicationModel model = parent.getModel();


	if (model.getData() == null )
	{
		return;
	}

	
	int i = 1;
	try
	{
		PrintWriter sortie = new PrintWriter( new FileWriter(filePath));

		sortie.println(getHTMLHeader(model.getLongitude()));
		
		sortie.println(getHTMLTableHeader());
		sortie.flush();

		String style ="";

		for (Enumeration e = model.getData().elements();e.hasMoreElements();)
		{
			String[] record = (String[])e.nextElement();

			if ((i%2)>0)
			{
				style = "impaire";
			}
			else
			{
				style = "paire";
			}
			

			sortie.println(	"<TR class=\""+style+"\" ><TD>" +Integer.toString(i) + "</TD><TD>"+
							record[model.DATE]+"</TD><TD>"+
							record[model.LOC_SID_TIME_H]+" h "+
							record[model.LOC_SID_TIME_M]+"</TD><TD>"+
							record[model.LOC_SID_TIME_18HTU_H]+" h "+
							record[model.LOC_SID_TIME_18HTU_M]+"</TD><TD>"+
							record[model.LOC_SID_TIME_22HTU_H]+" h "+
							record[model.LOC_SID_TIME_22HTU_M]+"</TD></TR>");
			sortie.flush();
			i++;
		}
		sortie.println(getHTMLTableFooter());
		sortie.println(getHTMLFooter());
		sortie.close();
			
	}
	catch (Exception ex)
	{
		
		d = new Dialog(parent.getFrame()," Erreur ! ");
		d.setSize(200,100);
		d.addWindowListener(new WindowListener(){
				public void windowOpened(WindowEvent ev){};
				public void windowActivated(WindowEvent ev){}
				public void windowIconified(WindowEvent ev){}
				public void windowClosed(WindowEvent ev){}
				public void windowClosing(WindowEvent ev){
						d.dispose();
					}
				public void windowOpened(WindowEvent ev){}
				public void windowDeactivated(WindowEvent ev){}
				public void windowDeiconified(WindowEvent ev){}
							
			});
		Panel p = new Panel(new BorderLayout());
		
		Label msg = new Label(" Message : "+ ex.getMessage());
		p.add(msg,BorderLayout.CENTER);
		d.add(p);
		d.setVisible(true);
	}
	

	

	
}
}