package fr.wfn.astro.time.utils;


import java.lang.String;
/**
 * This class was generated by a SmartGuide.
 * 
 */
public class CalendarConverter {
	
	private double 	JD ; // Jour Julien
	private double				T  ; // Siecle Julien
	
	// Calendrier Grgorien
	private int				A	; // Anne 
	private int				M	; // Mois
	private int				J	; // Jour

	
	// Temps Universel
	
	private double			jd ; // Jour dcimal
	private int				HTU; // Heure TU
	private int				MTU; // Minute TU
	private double			STU; // Seconde TU

	


/**
 *
 * Constructeur : initialise le jour Julien
 *
 *
 * This method was created by a SmartGuide.
 * @param JD double
 */
public CalendarConverter ( double JD) {
	this.JD = JD;
	convertJDToDate(JD);
}
/**
 * This method was created by a SmartGuide.
 *
 * Algorithme : pg61, Jean Meeus, Astronomy Algorithme
 *
 * @param D int   Jour
 * @param M int   Mois
 * @param Y int   Anne
 */
public CalendarConverter ( int D, int M, int Y) {
	
	dateToJD(D,M,Y,0,0,0);

	A = Y;
	this.M = M;
	J = D;
	jd = (double)D;
	HTU = 0;
	MTU = 0;
	STU = 0; 
	
}
/**
 * This method was created by a SmartGuide.
 * @param D int
 * @param M int
 * @param Y int
 * @param H int
 * @param m int
 * @param s int
 */
public CalendarConverter ( int D, int M, int Y,int H, int m, double s ) {
	
	dateToJD(D,M,Y,H,m,s);
	
	this.A = Y;
	this.M = M;
	this.J = D;
	this.jd = (double)D+(double)H/24+(double)m/1440+s/86400;
	this.HTU = H;
	this.MTU = m;
	this.STU = s; 
	
}
/**
 * 
 * convertit le jour julien en anne, mois, jour, heure 
 * algo p. 63 Jean Meeus
 *
 * This method was created by a SmartGuide.
 * @param JD double
 */
private void  convertJDToDate (double JourJulien ) {
	
	JourJulien = JourJulien + 0.5;
	
	int z = (int) JourJulien;
	double F = JourJulien - (double) z;
	
	int a;
	
	if (z< 2299161){
		a=z;}
	else {
		int alpha = (int)(((double)z-1867216.25)/36524.25);
		a = z+1+alpha-(int)((double)alpha/4);
		};	
	int B = a+1524;
	int C = (int)(((double)B-122.1)/365.25);
	int D = (int)(365.25*(double)C);
	int E = (int)((double)(B-D)/30.6001);
	
	jd = (double)(B-D-(int)(30.6001*(double)E))+F;
	J = (int)(jd);
	
	HTU = (int)((jd-(double)J)*24);
	MTU = (int)((jd-(double)J)*24*60-(double)HTU*60);
	STU = ((jd-(double)J)*24*60-(double)HTU*60)*60-(double)MTU*60;
	
	if (E<14) {
		M = E-1;}
	else {
		M=E-13; };

	if (M>2) {
		A=C-4716;}
	else {
		A=C-4715;};
	
	return;
}
/**
 * This method was created by a SmartGuide.
 *
 * Convertit la Date Grgorienne en Jour Julien
 * Meeus,  
 *
 *
 * @param D int Jour
 * @param M int Mois
 * @param Y int Anne
 * @param H int Heure TU
 * @param m int minute TU
 * @param s int seconde TU
 */
private void dateToJD (int D, int M, int Y,int H, int m, double s ) {

	int A ; 
	int B ;
	double julianDay;
	
	if (M<3) { Y = Y-1 ; M = M + 12 ;};
	
	A = (int)((double)Y/100);
	B = 2 - A +  (int)((double)A/4);
	
	julianDay = (double)((int)(365.25*(4716+(double)Y))+ (int)(30.6001*((double)M+1)))+D+B - 1524.5 +(double)H/24+(double) m/1440+ s/86400; 
		
	this.JD = julianDay;

	
	return;
}
/**
 * This method was created by a SmartGuide.
 */
public int getAnnee( ) {
	
	return A;
}
/**
 * This method was created by a SmartGuide.
 * @return java.lang.String
 */
public String getDate ( ) {
	String str = "";
	String str1 = 	str.valueOf(this.J);
	String str2 =  str.valueOf(this.M); 
	String str3 =  str.valueOf(this.A);
	
	return " "+str1+"/"+str2+"/"+str3;
}
/**
 * This method was created by a SmartGuide.
 * @return java.lang.String
 */
public String getHeure ( ) {
	String str = "";
	String str1 = 	str.valueOf(this.HTU);
	String str2 =  str.valueOf(this.MTU); 
	String str3 =  str.valueOf(this.STU);
	
	return " "+str1+"H"+str2+"m"+str3+"s";

}
/**
 * This method was created by a SmartGuide.
 * @return int
 */
public int getHTU ( ) {
	return HTU;
}
/**
 * This method was created by a SmartGuide.
 */
public double getJD( ) {
	
	return JD;
}
/**
 * This method was created by a SmartGuide.
 * @return int
 */
public int getJour ( ) {
	//convertJDToDate(JD);

	return J;
}
/**
 * This method was created by a SmartGuide.
 * @return double
 */
public double getJourDeci ( ) {
	//convertJDToDate(JD);
	return jd;
}
/**
 * This method was created by a SmartGuide.
 * @return int
 */
public int getMois ( ) {
	//	convertJDToDate(JD);
	return M;
}
/**
 * This method was created by a SmartGuide.
 * @return int
 */
public int getMTU ( ) {
	return MTU;
}
/**
 * This method was created by a SmartGuide.
 * @return double
 */
public double getSTU ( ) {
	return STU;
}
/**
 *
 * retourne le siecle Julien pour l'epoque J.2000.0   Meeus p. 151
 *
 * This method was created by a SmartGuide.
 * @return double
 */
public double getT2000 ( ) {
	
	return (JD-2451545.0)/36525;
}
/**
 * This method was created by a SmartGuide.
 */
public void setDate(int D, int M, int Y) {
	
	dateToJD(D,M,Y,0,0,0);
	
	this.A = Y;
	this.M = M;
	this.J = D;
	this.jd = (double)D;
	this.HTU = 0;
	this.MTU = 0;
	this.STU = 0; 
	return;
}
/**
 * This method was created by a SmartGuide.
 */
public void setDate ( int D, int M, int Y,int H, int m, double s ) {
	
	dateToJD(D,M,Y,H,m,s);
	
	this.A = Y;
	this.M = M;
	this.J = D;
	this.jd = (double)D+(double)H/24+(double)m/1440+s/86400;
	this.HTU = H;
	this.MTU = m;
	this.STU = s; 
	
	return;
}
/**
 * This method was created by a SmartGuide.
 * @param JD double
 */
public void setJD (double JD ) {
	this.JD = JD;
	convertJDToDate(JD);
	return;
}
}