package fr.wfn.astro.time.utils;

/**
 * Ce type a t cr dans VisualAge.
 */
public class SideralTime {
	private double _CurrentJulianDay = 0;
	private double _T = 0;
	// Mean Sideral Time Greenwich at 0 UT in Deg
	private double _MSTG0UTDeg = 0;
	// Mean Sideral Time Greenwich at 0 UT in hours
	private double _MSTG0UT = 0;
	private double _CurrentUT  = 0;

	// sidral Time
	private int _LocSidH = 0;
	private int _LocSidM = 0;
/**
 * Commentaire relatif au constructeur SideralTime.
 */
public SideralTime() {
	super();

	
}
/**
 * Cette mthode a t cre dans VisualAge.
 * @return int
 */
public int getSideralHour() {

	return 	_LocSidH;
}
/**
 * Cette mthode a t cre dans VisualAge.
 * @return int
 */
public int getSideralMinute() {

	return 	_LocSidM;
}
/**
 * Meeus Chap 12 Sideral Time at Greewich pg 87.
 * @param YYYY double
 * @param MM double
 * @param DD double
 * @param H double
 * @param M double
 * @param longitude double
 */
public void setTime(int YYYY,int MM, int DD, int H, int M,double longitude) {

	_CurrentJulianDay = (new CalendarConverter(DD,MM,YYYY)).getJD();
	_CurrentUT =(double) H+(double)M/60;
	_T = (_CurrentJulianDay - 2451545.0)/36525;

	_MSTG0UTDeg = 100.46061837
					+ 36000.770053608*_T
					+ 0.000387933*_T*_T
					- _T*_T*_T/38710000;
	
	// correction de latitude
	double _MSTUTDeg = _MSTG0UTDeg - longitude+((double)H + (double)M/60)*1.0027379/24*360;
	

	_MSTUTDeg = _MSTUTDeg%360;
	
				
	double _MSTUT = _MSTUTDeg/360*24;;

	_LocSidH = (int)_MSTUT;
	_LocSidM = (int)(_MSTUT*60-(double)_LocSidH*60);

}
}